#****************************************************************************
#**
#**  File     :  /lua/EffectUtilities.lua
#**  Author(s):  Gordon Duclos
#**
#**  Summary  :  Effect Utility functions for scripts.
#**
#**  Copyright  2006 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************
local util = import('/lua/utilities.lua')
local Entity = import('/lua/sim/Entity.lua').Entity
local EffectTemplate = import('/lua/EffectTemplates.lua')

function SpawnBuildBots( builder, unitBeingBuilt, numBots,  BuildEffectsBag )
    local army = builder:GetArmy()
    local BeamBuildEmtBp = '/effects/emitters/build_beam_02_emit.bp'
    local x, y, z = unpack(builder:GetPosition())
    local qx, qy, qz, qw = unpack(builder:GetOrientation())

    local numUnits = numBots
    local angle = (2*math.pi) / numUnits
    local angleInitial = 180
    local VecMul = 0.5

    local xVec = 0
    local yVec = builder:GetBlueprint().SizeY * 0.5
    local zVec = 0
    local BuilderUnits = {}
    local tunit = nil

    # Launch projectiles at semi-random angles away from the sphere, with enough
    # initial velocity to escape sphere core
    for i = 0, (numUnits - 1) do
        xVec = math.sin(angleInitial + (i*angle)) * VecMul
        zVec = math.cos(angleInitial + (i*angle)) * VecMul
        tunit = CreateUnit('IUX0001', army, x + xVec, y + yVec, z + zVec, qx, qy, qz, qw, 'Air' )
        table.insert( BuilderUnits, tunit )
        BuildEffectsBag:Add(tunit)
    end
    IssueGuard( BuilderUnits, unitBeingBuilt )
    return BuilderUnits
end