#****************************************************************************
#**
#**  Author(s):  Pheonix-IV
#**
#**  Summary  :  Shipyard Script
#**
#**  Copyright  2007 Firebird Industries.  All rights reserved.
#****************************************************************************

local TSeaFactoryUnit = import('/lua/cybranunits.lua').CLandFactoryUnit

IUB0101 = Class(TSeaFactoryUnit) {
    BuildBones = {
        BuildEffectBones = { 'CraneEnd01', 'CraneEnd02'},
        BuildAttachBone = 'Attachpoint01',
    },
    BuildAttachBone = 'Attachpoint01',
    
    OnStopBeingBuilt = function(self,builder,layer)
        TSeaFactoryUnit.OnStopBeingBuilt(self,builder,layer)
        self.EffectsBag = {}
        self.OpenAnimationManip = CreateAnimator(self)
        self.OpenAnimationManip:PlayAnim(self:GetBlueprint().Display.AnimationOpenManip, false):SetRate(0)
        self.BuildingAnimationManip = CreateAnimator(self)
        self.BuildingAnimationManip:PlayAnim(self:GetBlueprint().Display.AnimationBuildManip, false):SetRate(0)
        self.ReleaseEffectsBag = {}
        ChangeState(self, self.IdleState)
    end,

    OnFailedToBuild = function(self)
        TSeaFactoryUnit.OnFailedToBuild(self)
        ChangeState(self, self.IdleState)
    end,

    IdleState = State {
        OnStartBuild = function(self, unitBuilding, order)
            TSeaFactoryUnit.OnStartBuild(self, unitBuilding, order)
            self.UnitBeingBuilt = unitBuilding
            self.OpenAnimationManip:SetRate(1)
            ChangeState(self, self.BuildingState)
        end,

        Main = function(self)
            self.OpenAnimationManip:SetRate(-1)
            self:DetachAll(self.BuildAttachBone)
            self:SetBusy(false)
        end,

    },

        OnStopBuild = function(self, unitBeingBuilt)
            TSeaFactoryUnit.OnStopBuild(self, unitBeingBuilt)
            ChangeState(self, self.IdleState)
        end,

}

TypeClass = IUB0101