#****************************************************************************
#**
#**  Author:  Pheonix-IV
#**
#**  Summary  :  Pioneer Script
#**
#**  Copyright  2007 Firebird Industries.  All rights reserved.
#****************************************************************************

local CConstructionUnit = import('/mods/highseas/lua/imperialunits.lua').IConstructionUnit
local TIFArtilleryWeapon = import('/lua/terranweapons.lua').TIFArtilleryWeapon

IUL0101 = Class(CConstructionUnit) {

    BuildBones = {
        YawBone = 'AttachPoint',
        PitchBone = 'AttachPoint',
        BuildEffectBones = {'AttachPoint','AttachPoint','AttachPoint','AttachPoint','AttachPoint',},
    },
    Weapons = {
        Cannon01 = Class(TIFArtilleryWeapon) {},
        Cannon02 = Class(TIFArtilleryWeapon) {},
    },
    
    OnCreate = function(self,builder,layer)
        CConstructionUnit.OnCreate(self,builder,layer)
        self.AnimManip = CreateAnimator(self)
        self.AnimManip:PlayAnim(self:GetBlueprint().Display.AnimationOnLand, false):SetRate(0)
    end,
    
    OnLayerChange = function(self, new, old)
        CConstructionUnit.OnLayerChange(self, new, old)
            local myBlueprint = self:GetBlueprint()
            if( new == 'Land' ) then
                self.AT1 = self:ForkThread(self.TransformThread, false)
            elseif( new == 'Water' ) then
                self.AT1 = self:ForkThread(self.TransformThread, true)
            end
    end,
    
    TransformThread = function(self, land)
        if( land ) then
            self.AnimManip:SetRate(-1)
            WaitFor(self.AnimManip)
            self.Walking = false
        else
            self.AnimManip:SetRate(1)
            WaitFor(self.AnimManip)
            self.Walking = true
        end
    end,
}

TypeClass = IUL0101