#****************************************************************************
#**
#**  Author(s):  Pheonix-IV
#**
#**  Summary  :  Ship o' the Line Script
#**
#**  Copyright  2007 Firebird Industries.  All rights reserved.
#****************************************************************************
local TSeaUnit = import('/lua/terranunits.lua').TSeaUnit
local TIFArtilleryWeapon = import('/lua/terranweapons.lua').TIFArtilleryWeapon
local TIFFlagshipDeathWeapon = import('/lua/terranweapons.lua').TIFCommanderDeathWeapon
local explosion = import('/lua/defaultexplosions.lua')
local CreateDeathExplosion = explosion.CreateDefaultHitExplosionAtBone

UEL0001 = Class(TSeaUnit) {

	BuildAttachBone = 'Attachpoint',

    Weapons = {
		DeathWeapon = Class(TIFFlagshipDeathWeapon) {},
        CannonRack01 = Class(TIFArtilleryWeapon) {},
        CannonRack02 = Class(TIFArtilleryWeapon) {},
        CannonRack03 = Class(TIFArtilleryWeapon) {},
        CannonRack04 = Class(TIFArtilleryWeapon) {},
        CannonRack05 = Class(TIFArtilleryWeapon) {},
        CannonRack06 = Class(TIFArtilleryWeapon) {},
        CannonRack07 = Class(TIFArtilleryWeapon) {},
        CannonRack08 = Class(TIFArtilleryWeapon) {},
        CannonRack09 = Class(TIFArtilleryWeapon) {},
    },
     
    PlayCommanderWarpInEffect = function(self)
        self:SetUnSelectable(true)
        self:SetBlockCommandQueue(true)
        self:ForkThread(self.WarpInEffectThread)
    end,

    WarpInEffectThread = function(self)
        self:PlayUnitSound('CommanderArrival')
        self:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
        WaitSeconds(2.1)
        self:SetUnSelectable(false)
        self:SetBlockCommandQueue(false)

        local totalBones = self:GetBoneCount() - 1
        local army = self:GetArmy()
    end,
    
    DeathThread = function(self)
		local watchBone = 'Bote'
		local pos = self:GetPosition()
		local seafloor = GetTerrainHeight(pos[1], pos[3]) + GetTerrainTypeOffset(pos[1], pos[3])
			while self:GetPosition(watchBone)[2] > seafloor do
				WaitSeconds(0.2)
			end
		CreateDeathExplosion( self, 'Bote', 10)
		self:CreateWreckage(0.6)
		self:Destroy()
		self:DestroyIdleEffects()
    end
}

TypeClass = UEL0001